package com.ardublock.translator.block.communication;

import com.ardublock.translator.Translator;
import com.ardublock.translator.block.TranslatorBlock;
import com.ardublock.translator.block.exception.SocketNullException;
import com.ardublock.translator.block.exception.SubroutineNotDeclaredException;

public class SoftSerialReadBlock extends TranslatorBlock
{
	public SoftSerialReadBlock(Long blockId, Translator translator, String codePrefix, String codeSuffix, String label)
	{
		super(blockId, translator, codePrefix, codeSuffix, label);
	}

	@Override
	public String toCode() throws SocketNullException, SubroutineNotDeclaredException
	{
		/**
		 * DO NOT add tab in code any more, we'll use arduino to format code, or the code will duplicated. 
		 */		
		translator.addHeaderFile("SoftwareSerial.h");
		
		TranslatorBlock tB1 = this.getRequiredTranslatorBlockAtSocket(0);//Pin Rx
		TranslatorBlock tB2 = this.getRequiredTranslatorBlockAtSocket(1);//Pin Tx
		//String SerialNumber = tB1.toCode().replaceAll("\\s*_.new\\b\\s*", "") + tB2.toCode().replaceAll("\\s*_.new\\b\\s*", "");
		
		String SerialName = label.trim();
		if(SerialName.contains(" ")) {
			SerialName = SerialName.substring(0, SerialName.indexOf(" "));
		}
		
		/*if(!translator.containsSetupCommand("softSerial"+SerialNumber+".begin")){
			translator.addSetupCommand("softSerial"+SerialNumber+".begin(4800);");
			translator.addDefinitionCommand("SoftwareSerial softSerial"+SerialNumber+"(" + tB1.toCode().replaceAll("\\s*_.new\\b\\s*", "") + ", "+ tB2.toCode().replaceAll("\\s*_.new\\b\\s*", "") +");\n");
		}*/
		
		if(!translator.containsSetupCommand(SerialName+".begin")){
			translator.addSetupCommand(SerialName+".begin(4800);");
			translator.addDefinitionCommand("SoftwareSerial "+SerialName+"(" + tB1.toCode().replaceAll("\\s*_.new\\b\\s*", "") + ", "+ tB2.toCode().replaceAll("\\s*_.new\\b\\s*", "") +");\n");
		}
		
		//String ret = "softSerial"+SerialNumber+".read()";
		String ret = SerialName+".read()";
		
		return codePrefix+ret+codeSuffix;
	}
}
