package com.ardublock.translator.block.didacticnetwork;

import java.util.ResourceBundle;

import com.ardublock.translator.Translator;
import com.ardublock.translator.block.TranslatorBlock;
import com.ardublock.translator.block.exception.BlockException;
import com.ardublock.translator.block.exception.SocketNullException;
import com.ardublock.translator.block.exception.SubroutineNotDeclaredException;
import com.ardublock.translator.block.numbers.LocalVariableStringBlock;
import com.ardublock.translator.block.numbers.StringBlock;
import com.ardublock.translator.block.numbers.VariableStringBlock;


public class PsnReadPayloadBlock extends TranslatorBlock
{
	private static ResourceBundle uiMessageBundle = ResourceBundle.getBundle("com/ardublock/block/ardublock");

	public PsnReadPayloadBlock(Long blockId, Translator translator, String codePrefix, String codeSuffix, String label)
	{
		super(blockId, translator, codePrefix, codeSuffix, label);
	}

	@Override
	public String toCode() throws SocketNullException, SubroutineNotDeclaredException
	{
		
		//Label autoText set in edu.mit.blocks.renderable.BlockLabel -> generateLabelText()
		
		String name = label.trim();
		if(name.contains(" ")) {
			name = name.substring(0, name.indexOf(" "));
		}
		
		TranslatorBlock tb_stringVar = getRequiredTranslatorBlockAtSocket(0);
		
		String stringVar = tb_stringVar.toCode().replaceAll("\\s*_.new\\b\\s*", "");
		
		translator.addDefinitionCommand("char "+stringVar+"[MAX_LEN_PAYLOAD+1] = \"\\0\";");
		
		if(!(tb_stringVar instanceof VariableStringBlock) && !(tb_stringVar instanceof LocalVariableStringBlock)) {
			throw new BlockException(blockId, uiMessageBundle.getString("ardublock.error_msg.string_var_slot"));
		}

		return name + ".readPayload("+stringVar+");";	
	}
}
